local coreDamageCalc = PSO.lib.damageCalc

PSO.lib.damageCalc = function(mo, inflictor)
	local source = inflictor.target
	local minfo = mo.pso or mo.player.pso
	
	--Shifta Enchant
	if source and source.player and source.player.pso 
	and PSO.lib.hasSkill(source.player,   "fo_shiftaenchant")
	and source.player.pso.enchant
	and not inflictor.pso.element
		inflictor.pso.element = source.player.pso.enchant
	end
	
	local damage = coreDamageCalc(mo, inflictor)
	
	--Outgoing Damage
	if source and source.player and source.player.pso
		local weapon = PSO.lib.getPlayerActiveWeapon(source.player)
		
		--Deadline Slayer
		if PSO.lib.hasSkill(source.player, "hu_deadline") 
		and source.player.pso.hp < source.player.pso.maxhp*30/100
			damage = $ * 120/100
		end
		
		--Overload/Fury Stance
		if PSO.lib.hasSkill(source.player, "hu_overload")
			damage = $ * 110/100
		end
		
		--Guard Stance
		if PSO.lib.hasSkill(source.player, "hu_guardstance")
			damage = $ * 90/100
		end
		
		--First Hit
		if PSO.lib.hasSkill(source.player, "ra_firsthit")
		and minfo and minfo.hp == minfo.maxhp
			damage = $ * 120/100
		end
		
		--Sharp Shooter
		if PSO.lib.hasSkill(source.player, "ra_sharpshooter")
			local distanceMulti = min(10, R_PointToDist2(source.x, source.y, mo.x, mo.y) / (100 * FRACUNIT))
			damage = $ * (100 + distanceMulti) / 100
		end
		
		--Zero Range
		if PSO.lib.hasSkill(source.player, "ra_zerorange")
			local zeroRangeMulti = max(50, 500-R_PointToDist2(source.x, source.y, mo.x, mo.y) / FRACUNIT)
			zeroRangeMulti = $ / 5
			damage = $ * (100 + zeroRangeMulti) / 100
		end
		
		--Element Conversion
		if PSO.lib.hasSkill(source.player, "fo_elementconversion")
			local convertMulti = weapon.elementv/10
			if weapon.element == inflictor.pso.element
				convertMulti = $ * 2
			end
			damage = $ * (100 + convertMulti)/100
		end
		
		--Element Weak Hit
		if PSO.lib.hasSkill(source.player, "fo_weakhit") and minfo 
			if minfo.weakness == inflictor.pso.element
				damage = $ * 110/100
			end
		end
	end
	
	--Incoming Damage
	if mo.player and mo.player.pso
		--Overload/Fury Stance
		if PSO.lib.hasSkill(mo.player, "hu_overload")
			damage = $ * 110/100
		end
		
		--Guard Stance
		if PSO.lib.hasSkill(mo.player, "hu_guardstance")
			damage = $ * 90/100
		end
	end
		
	return max(1, damage)
end