local coreKillObject = PSO.lib.killObject

PSO.lib.killObject = function(mo, inflictor)
	local source = inflictor and inflictor.target
	coreKillObject(mo, inflictor)
	
	--For killer only
	if source and source.player
		--Adrenaline
		if PSO.lib.hasSkill(source.player, "hu_adrenaline")
			local duration = 6*TICRATE
			source.player.pso.shifta = $ or 0
			source.player.pso.shifta = min(180*TICRATE, $+duration)
			source.player.pso.deband = $ or 0
			source.player.pso.deband = min(180*TICRATE, $+duration)
		end
	end
	
	--For all players
	for p in players.iterate do
		local pmo = p.mo
		if not pmo or not pmo.valid continue end
		
		if R_PointToDist2(pmo.x, pmo.y, mo.x, mo.y) < 768*mo.scale
			-- Absorption
			if PSO.lib.hasSkill(p, "hu_absorb")
				S_StartSoundAtVolume(pmo, sfx_heal, 127)
				for i = 1, 8
					local s = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SUPERSPARK)
					s.destscale = 1
					s.momx = P_RandomRange(-32, 32)*FRACUNIT
					s.momy = P_RandomRange(-32, 32)*FRACUNIT
					s.momz = P_RandomRange(-32, 32)*FRACUNIT
					s.colorized = true
					s.color = SKINCOLOR_GREEN
				end
				PSO.lib.healObject(pmo, pmo, 20)
			end	
			
			-- Killing Bonus
			if PSO.lib.hasSkill(p, "ra_killbonus")
				S_StartSoundAtVolume(pmo, sfx_cburst, 127)
				for i = 1, 8
					local s = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SUPERSPARK)
					s.destscale = 1
					s.momx = P_RandomRange(-32, 32)*FRACUNIT
					s.momy = P_RandomRange(-32, 32)*FRACUNIT
					s.momz = P_RandomRange(-32, 32)*FRACUNIT
					s.colorized = true
					s.color = SKINCOLOR_BLUE
				end
				p.pso.pp = min(p.pso.maxpp, p.pso.pp+15)
			end	
			
		end
	end
end